@echo off
rem ****************************************************** {COPYRIGHT-TOP} ***
rem Licensed Materials - Property of IBM
rem 5724-M07, 5698-A77
rem
rem (C) Copyright IBM Corp. 2006 All Rights Reserved.
rem
rem US Government Users Restricted Rights - Use, duplication, or
rem disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem ****************************************************** {COPYRIGHT-END} ***

set JARFILE=kd4dcagent.jar
set dat=%date:~4,2%-%date:~7,2%-%date:~10,4%
set tim=%time:~0,2%%time:~3,2%%time:~6,2%%time:~9,2%

:checkJBOSSInstall
if not %3==USE_ENV_HOME goto useJBOSSfromCmdLine
goto useJBOSSfromENV

:useJBOSSfromCmdLine
set KD4_JBOSS_HOME=%3
goto check_jboss_type

:useJBOSSfromENV
if  not exist "%JBOSS_HOME%" goto jboss_home_invalid
set KD4_JBOSS_HOME=%JBOSS_HOME%
goto check_jboss_type

:jboss_home_invalid
set ERRORLEVEL=170
echo Cannot find the JBOSS_HOME directory.
goto end


:check_jboss_type
set JBOSS_TYPE=%2
Rem check if JBOSS_TYPE directory is exist
if exist %KD4_JBOSS_HOME%\server\%JBOSS_TYPE% goto backupXmlFile
echo Can not find %KD4_JBOSS_HOME%\server\%JBOSS_TYPE% directory. 
echo Use a server configuration name that exists in this installation.
goto wrongJbossType



:check_enable_type
for %%q in (%4) do set NO_QUOTES_KD4_DIR=%%~q
set ENABLE_TYPE=%1
if "%ENABLE_TYPE%" == "-enable" goto enable
if "%ENABLE_TYPE%" == "-disable" goto deletejar
GOTO syntaxError


:enable
copy /y "%NO_QUOTES_KD4_DIR%"\KD4\lib\%JARFILE% "%KD4_JBOSS_HOME%"\server\%JBOSS_TYPE%\lib > null
if "%ERRORLEVEL%"=="0" goto foundJBOSS
goto copyfailed


:deletejar
del /f "%KD4_JBOSS_HOME%"\server\%JBOSS_TYPE%\lib\%JARFILE%
if not exist "%KD4_JBOSS_HOME%"\server\%JBOSS_TYPE%\lib\%JARFILE% goto foundJBOSS
goto deletefailed

:backupXmlFile
copy /y %KD4_JBOSS_HOME%\server\%JBOSS_TYPE%\deploy\jboss-ws4ee.sar\META-INF\axis-client-config.xml %KD4_JBOSS_HOME%\server\%JBOSS_TYPE%\deploy\jboss-ws4ee.sar\META-INF\axis-client-config.%dat%%tim%.bk.xml > null
copy /y %KD4_JBOSS_HOME%\server\%JBOSS_TYPE%\deploy\jboss-ws4ee.sar\META-INF\axis-server-config.xml %KD4_JBOSS_HOME%\server\%JBOSS_TYPE%\deploy\jboss-ws4ee.sar\META-INF\axis-server-config.%dat%%tim%.bk.xml > null
goto check_enable_type

set ERRORLEVEL=156
goto checkErrorLevel

:foundJBOSS
set SAVE_CP=%CLASSPATH%            
set NEW_CP="%CLASSPATH%;%NO_QUOTES_KD4_DIR%\KD4\lib\jdom.jar;%NO_QUOTES_KD4_DIR%\KD4\lib\crystal.jboss.install.jar;%NO_QUOTES_KD4_DIR%\KD4\lib\kd4dcagent.jar;"
set CLASSPATH=%NEW_CP%
set ERRORLEVEL=
java com.ibm.management.soa.agent.jboss.install.WSDMAgentService %ENABLE_TYPE% %JBOSS_TYPE% %KD4_JBOSS_HOME%
:checkErrorLevel                                                                                                 
IF %ERRORLEVEL%==0 GOTO OK
echo The installation utility failed with RC = %ERRORLEVEL%.
GOTO END

:syntaxError
set ERRORLEVEL=100
goto end

:copyfailed
set ERRORLEVEL=171
goto end

:deletefailed
set ERRORLEVEL=172
goto end

:wrongJbossType
set ERRORLEVEL=173
goto end

:OK
set ERRORLEVEL=0
echo The installation utility completed successfully.
GOTO END
  
:END
set CLASSPATH=%SAVE_CP%

